package geometry.collections;

import geometry.methods.Point2D;

import java.util.Scanner;

public class TestPoint2D_Collections {
	
	public static void readCoordinates(Point2D p) {
		Scanner sc = new Scanner(System.in);
		System.out.println("Reading coordinates: ");
		System.out.println("x? ");
		p.x = sc.nextDouble();
		System.out.println("y? ");
		p.y = sc.nextDouble();
	}
	
	public static void printCoordinates(Point2D p) {
		System.out.println("(" + p.x + ", " + p.y + ")");
	}
	
	public static double distance(Point2D a, Point2D b) {
		double distance;
		distance = Math.sqrt( Math.pow(a.x-b.x, 2) + Math.pow(a.y-b.y, 2) );
		return distance;
	}
	
	public static Point2D midPoint(Point2D a, Point2D b) {
		Point2D mid = new Point2D();
		mid.x = (a.x + b.x) / 2.0;
		mid.y = (a.y + b.y) / 2.0;
		return mid;				
	}
	
	public static void main(String [] args) {
		// Array definition
		Point2D [] points = new Point2D[10];
		
		// Array elements allocation and initialization
		for(int i=0; i<points.length; i++) {
			points[i] = new Point2D();
			readCoordinates(points[i]);
		}
		
		// Calculations: get the two closest points
		int k=-1, l=-1;
		double minDistance = Double.MAX_VALUE;
		
		for(int i=0; i<points.length; i++) {
			for(int j=i+1; j<points.length; j++) {				
				double d = distance(points[i], points[j]);
				if(d < minDistance) {
					minDistance = d;
					k = i;
					l = j;
				}
			}
		}
		
		// Print results
		System.out.println("Closest points: ");
		System.out.print("Point " + k + ": ");
		printCoordinates(points[k]);
		System.out.print("Point " + l + ": ");
		printCoordinates(points[l]);
	}
}
