package matrix.methods;

public class Matrix {
	
	private int rows;
	private int cols;
	private double [][] values;
	
	/** Constructors */
	public Matrix(int r, int c) {
		this.rows = r;
		this.cols = c;
		this.values = new double[r][c];
	}
	
	/** Random initialization of the matrix */
	public void randomInitialization() {
		
		// Initialize values
		for(int i=0; i<this.rows; i++)
			for(int j=0; j<this.cols; j++)
				this.values[i][j] = Math.random();
	}

	/** Random initialization of the matrix */
	public void randomInitialization(double a, double b) {
		
		// Initialize values
		for(int i=0; i<this.rows; i++)
			for(int j=0; j<this.cols; j++)
				this.values[i][j] = a + (b-a)*Math.random();
	}
	
	/** Print matrix */
	public void print() {
		for(int i=0; i<rows; i++) {
			for(int j=0; j<cols; j++)
				System.out.print(values[i][j] + " ");
			System.out.println();
		}
	}
	
	/** Add matrices
	 *  @param m Matrix (m must proper size)
	 *  @return Result of the addition operation */
	public Matrix add(Matrix m) {
		Matrix r = new Matrix(rows, cols);
		for(int i=0; i<rows; i++)
			for(int j=0; j<cols; j++)
				r.values[i][j] = values[i][j] + m.values[i][j];
		
		return r;
	}
	
	/** Subtract matrices
	 *  @param m Matrix (m must have proper size)
	 *  @return Result of the addition operation */
	public Matrix sub(Matrix m) {
		Matrix r = new Matrix(rows, cols);
		
		for(int i=0; i<rows; i++)
			for(int j=0; j<cols; j++)
				r.values[i][j] = values[i][j] - m.values[i][j];
		
		return r;
	}
}
